/**
* Mindfull Project: this program is to calculate the average EEG amplitudes for each session a single participant .

   When the signal quality is good (i.e when poor signal is zero), and if the gameplay time is greater than the default time taken to collect a token,
   the EEG amplitudes per session is computed for all the sessions for a single participant
  
*/

import java.util.ArrayList;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.io.PrintStream;
import java.io.FileOutputStream;


/* Created by srilekha Kirshnamachari  on 2016-06-01.
*/

class AverageEEG {

/*pinwheel game variables */

static ArrayList<Double> tempArrayPinLowAlpha;
static ArrayList<Double> tempArrayPinLowBeta;
static ArrayList<Double> tempArrayPinHighAlpha;
static ArrayList<Double> tempArrayPinHighBeta;
static ArrayList<Double> tempArrayPinLowGamma;
static ArrayList<Double> tempArrayPinHighGamma;
static ArrayList<Double> tempArrayPinDelta;
static ArrayList<Double> tempArrayPinTheta;

/*paraglider game variables */
static ArrayList<Double> tempArrayParaLowAlpha;
static ArrayList<Double> tempArrayParaLowBeta;
static ArrayList<Double> tempArrayParaHighAlpha;
static ArrayList<Double> tempArrayParaHighBeta;
static ArrayList<Double> tempArrayParaLowGamma;
static ArrayList<Double> tempArrayParaHighGamma;
static ArrayList<Double> tempArrayParaDelta;
static ArrayList<Double> tempArrayParaTheta;

/*Rock game variables */
static ArrayList<Double> tempArrayRockLowAlpha;
static ArrayList<Double> tempArrayRockLowBeta;
static ArrayList<Double> tempArrayRockHighAlpha;
static ArrayList<Double> tempArrayRockHighBeta;
static ArrayList<Double> tempArrayRockLowGamma;
static ArrayList<Double> tempArrayRockHighGamma;
static ArrayList<Double> tempArrayRockDelta;
static ArrayList<Double> tempArrayRockTheta;



static boolean debug = false;
static boolean debug1 = true;

AverageEEG()
{
			
	tempArrayPinLowAlpha = new ArrayList<Double> ();
	tempArrayPinHighAlpha = new ArrayList<Double> ();
	tempArrayPinLowBeta = new ArrayList<Double> ();
	tempArrayPinHighBeta = new ArrayList<Double> ();
	tempArrayPinLowGamma = new ArrayList<Double> ();
	tempArrayPinHighGamma = new ArrayList<Double> ();
	tempArrayPinDelta = new ArrayList<Double> ();
	tempArrayPinTheta = new ArrayList<Double> ();
	
	tempArrayParaLowAlpha = new ArrayList<Double> ();
	tempArrayParaHighAlpha = new ArrayList<Double> ();
	tempArrayParaLowBeta = new ArrayList<Double> ();
	tempArrayParaHighBeta = new ArrayList<Double> ();
	tempArrayParaLowGamma = new ArrayList<Double> ();
	tempArrayParaHighGamma = new ArrayList<Double> ();
	tempArrayParaDelta = new ArrayList<Double> ();
	tempArrayParaTheta = new ArrayList<Double> ();
	
	tempArrayRockLowAlpha = new ArrayList<Double> ();
	tempArrayRockHighAlpha = new ArrayList<Double> ();
	tempArrayRockLowBeta = new ArrayList<Double> ();
	tempArrayRockHighBeta = new ArrayList<Double> ();
	tempArrayRockLowGamma = new ArrayList<Double> ();
	tempArrayRockHighGamma = new ArrayList<Double> ();
	tempArrayRockDelta = new ArrayList<Double> ();
	tempArrayRockTheta = new ArrayList<Double> ();
	
}

private static double average(ArrayList<Double> list) {


	/* test the array */
	if(debug) {
		for(double i : list)
		{
			System.out.print(i+",");
		}
		System.out.println("---------------------");
	}

	
	// 'average' is undefined if there are no elements in the list.
	if (list == null || list.isEmpty())
		return 0.0;
	// Calculate the summation of the elements in the list
	long sum = 0;
	int n = list.size();
	// Iterating manually is faster than using an enhanced for loop.
	for (int i = 0; i < n; i++)
	{
		sum += list.get(i);
	}  
	// We don't want to perform a Double division, so the cast is mandatory.
	return ((double) sum) / n;
}


private static void resetStaticArrays()
{
	 
							tempArrayPinDelta.clear();
							tempArrayPinTheta.clear();
							tempArrayPinLowAlpha.clear();
							tempArrayPinHighAlpha.clear();
							tempArrayPinLowBeta.clear();
							tempArrayPinHighBeta.clear();
							tempArrayPinLowGamma.clear();
							tempArrayPinHighGamma.clear();
							
							tempArrayParaDelta.clear();
							tempArrayParaTheta.clear();
							tempArrayParaLowAlpha.clear();
							tempArrayParaHighAlpha.clear();
							tempArrayParaLowBeta.clear();
							tempArrayParaHighBeta.clear();
							tempArrayParaLowGamma.clear();
							tempArrayParaHighGamma.clear();
							
							tempArrayRockDelta.clear();
							tempArrayRockTheta.clear();
							tempArrayRockLowAlpha.clear();
							tempArrayRockHighAlpha.clear();
							tempArrayRockLowBeta.clear();
							tempArrayRockHighBeta.clear();
							tempArrayRockLowGamma.clear();
							tempArrayRockHighGamma.clear();
	
}

private static void fileWrite()
{
	if(debug)
		System.out.println(" Enter File Writing function: line 147");
}

public static void ReadCSVFile() {
	String filename = "Input csv file";
	Scanner inputStream = null;
	String data = "";
	String signalString = "PoorSig: 0";
	String dummy = "";
	int previousSessionRecord = 1;
	int TotalPinTime = 0;
	int PinAboveThreshold = 0;
	int TotalParaTime = 0;
	int ParaAboveThreshold = 0;
	int TotalRockTime = 0;
	int RockAboveThreshold = 0;
	boolean Contains = true;
	
	try {

	
		//System.out.println("enter TRY");
		inputStream = new Scanner(new File(filename));
		inputStream.useDelimiter(",");
		
		PrintStream out = new PrintStream(new FileOutputStream("Output csv file*"));
		System.setOut(out);
		System.out.println("SessionNo,Game,BrainwaveType,AvgPotential,TotalRecords");


		while (inputStream.hasNext()) {
			data = inputStream.nextLine();
			String[] values = data.split(",");


			/*check if signal is zero - indicating good quality */
			if(values[4].equals(signalString) &&  values[3].equals("[MINDWAVE]")) {
				{
					
					//System.out.println("enter CONDITION 1");
				   
					/* check if the game is pin/para/rock */
					if( 
							(values[18].equals("Pin")) ||
							(values[18].equals("Para")) ||
							(values[18].equals("Rock")) 
							) {
								
						//		System.out.println("enter CONDITION 2");


						if (previousSessionRecord != Double.parseDouble(values[1]))  
					   //if previousSessionRecord is not same as current session no, then print
						{
							/* calculate the average for all eeg under each game */

								if(debug)
									System.out.println(tempArrayPinDelta);
								
							if(TotalPinTime > 5) /* if the pinwheel gameplay time is greater than default Pinwheel time */
							{
								System.out.println(previousSessionRecord + ",Pin,AverageDelta," +  average(tempArrayPinDelta) + "," + tempArrayPinDelta.size());
								System.out.println(previousSessionRecord + ",Pin,AverageTheta," +  average(tempArrayPinTheta) + "," + tempArrayPinTheta.size());
								System.out.println(previousSessionRecord + ",Pin,AverageLowAlpha," +  average(tempArrayPinLowAlpha) + "," + tempArrayPinLowAlpha.size());
								System.out.println(previousSessionRecord + ",Pin,AverageHighAlpah," +  average(tempArrayPinHighAlpha) + "," + tempArrayPinHighAlpha.size());
								System.out.println(previousSessionRecord + ",Pin,AverageLowBeta," +  average(tempArrayPinLowBeta) + "," + tempArrayPinLowBeta.size());
								System.out.println(previousSessionRecord + ",Pin,AverageHighBeta," + average(tempArrayPinHighBeta) + "," + tempArrayPinHighBeta.size());
								System.out.println(previousSessionRecord + ",Pin,AverageLowGamma," +  average(tempArrayPinLowGamma) + "," + tempArrayPinLowGamma.size());
								System.out.println(previousSessionRecord + ",Pin,AverageHighGamma," +  average(tempArrayPinHighGamma) + "," + tempArrayPinHighGamma.size());
							}
							else
							{
								
								System.out.println(previousSessionRecord + ",Pin,AverageDelta,0,0");
								System.out.println(previousSessionRecord + ",Pin,AverageTheta,0,0");
								System.out.println(previousSessionRecord + ",Pin,AverageLowAlpha,0,0");
								System.out.println(previousSessionRecord + ",Pin,AverageHighAlpah,0,0");
								System.out.println(previousSessionRecord + ",Pin,AverageLowBeta,0,0");
								System.out.println(previousSessionRecord + ",Pin,AverageHighBeta,0,0");
								System.out.println(previousSessionRecord + ",Pin,AverageLowGamma,0,0");
								System.out.println(previousSessionRecord + ",Pin,AverageHighGamma,0,0");
							}
								
							   // System.out.println(previousSessionRecord + ",Pin," +  ((float) PinAboveThreshold/TotalPinTime)*100+","+TotalPinTime );
						   

							if(TotalParaTime > 11) /* if the paraglider gameplay time is greater than default paraglider time */
							{
								System.out.println(previousSessionRecord + ",Para,AverageDelta," +  average(tempArrayParaDelta) + "," + tempArrayParaDelta.size());
								System.out.println(previousSessionRecord + ",Para,AverageTheta," +  average(tempArrayParaTheta) + "," + tempArrayParaTheta.size());
								System.out.println(previousSessionRecord + ",Para,AverageLowAlpha," +  average(tempArrayParaLowAlpha) + "," + tempArrayParaLowAlpha.size());
								System.out.println(previousSessionRecord + ",Para,AverageHighAlpah," +  average(tempArrayParaHighAlpha) + "," + tempArrayParaHighAlpha.size());
								System.out.println(previousSessionRecord + ",Para,AverageLowBeta," +  average(tempArrayParaLowBeta) + "," + tempArrayParaLowBeta.size());
								System.out.println(previousSessionRecord + ",Para,AverageHighBeta," +  average(tempArrayParaHighBeta) + "," + tempArrayParaHighBeta.size());
								System.out.println(previousSessionRecord + ",Para,AverageLowGamma," +  average(tempArrayParaLowGamma) + "," + tempArrayParaLowGamma.size());
								System.out.println(previousSessionRecord + ",Para,AverageHighGamma," +  average(tempArrayParaHighGamma) + "," + tempArrayParaHighGamma.size()); 
								
							}
							else
							{
								System.out.println(previousSessionRecord + ",Para,AverageDelta,0,0");
								System.out.println(previousSessionRecord + ",Para,AverageTheta,0,0");
								System.out.println(previousSessionRecord + ",Para,AverageLowAlpha,0,0");
								System.out.println(previousSessionRecord + ",Para,AverageHighAlpah,0,0");
								System.out.println(previousSessionRecord + ",Para,AverageLowBeta,0,0");
								System.out.println(previousSessionRecord + ",Para,AverageHighBeta,0,0");
								System.out.println(previousSessionRecord + ",Para,AverageLowGamma,0,0");
								System.out.println(previousSessionRecord + ",Para,AverageHighGamma,0,0");

							}

							if(TotalRockTime > 8) /* If the rock gameplay time is greater than default rock time */
							{
								System.out.println(previousSessionRecord + ",Rock,AverageDelta," +  average(tempArrayRockDelta) + "," + tempArrayRockDelta.size());
								System.out.println(previousSessionRecord + ",Rock,AverageTheta," +  average(tempArrayRockTheta) + "," + tempArrayRockTheta.size());
								System.out.println(previousSessionRecord + ",Rock,AverageLowAlpha," +  average(tempArrayRockLowAlpha) + "," + tempArrayRockLowAlpha.size());
								System.out.println(previousSessionRecord + ",Rock,AverageHighAlpah," +  average(tempArrayRockHighAlpha) + "," + tempArrayRockHighAlpha.size());
								System.out.println(previousSessionRecord + ",Rock,AverageLowBeta," +  average(tempArrayRockLowBeta) + "," + tempArrayRockLowBeta.size());
								System.out.println(previousSessionRecord + ",Rock,AverageHighBeta," +  average(tempArrayRockHighBeta) + "," + tempArrayRockHighBeta.size());
								System.out.println(previousSessionRecord + ",Rock,AverageLowGamma," +  average(tempArrayRockLowGamma) + "," + tempArrayRockLowGamma.size());
								System.out.println(previousSessionRecord + ",Rock,AverageHighGamma," +  average(tempArrayRockHighGamma) + "," + tempArrayRockHighGamma.size()); 
							}
							else
							{
								System.out.println(previousSessionRecord + ",Rock,AverageDelta,0,0");
								System.out.println(previousSessionRecord + ",Rock,AverageTheta,0,0");
								System.out.println(previousSessionRecord + ",Rock,AverageLowAlpha,0,0");
								System.out.println(previousSessionRecord + ",Rock,AverageHighAlpah,0,0");
								System.out.println(previousSessionRecord + ",Rock,AverageLowBeta,0,0");
								System.out.println(previousSessionRecord + ",Rock,AverageHighBeta,0,0");
								System.out.println(previousSessionRecord + ",Rock,AverageLowGamma,0,0");
								System.out.println(previousSessionRecord + ",Rock,AverageHighGamma,0,0");
							}

								/* iterate the session number */
								previousSessionRecord +=1; 

							   /* Reset all variables after printing current session number and going to next session
								*/
								TotalPinTime = 0;
								TotalParaTime = 0;
								TotalRockTime = 0;
						   
								resetStaticArrays();
							
							
							
						} //end - if checking session no are same.

							if(debug)
								System.out.println("value of 18 index"+ values[18]);

							
							if(values[18].equals("Pin"))
							{
							
							if(debug)
								System.out.println("Line 205: Collecting pinwheel");

							
							TotalPinTime += 1; /* count the total time in Pinwheel game */
							tempArrayPinDelta.add(Double.parseDouble(values[8]));
							tempArrayPinTheta.add(Double.parseDouble (values[9]));
							tempArrayPinLowAlpha.add(Double.parseDouble(values[10]));
							tempArrayPinHighAlpha.add(Double.parseDouble(values[11]));
							tempArrayPinLowBeta.add(Double.parseDouble(values[12]));
							tempArrayPinHighBeta.add(Double.parseDouble(values[13]));
							tempArrayPinLowGamma.add(Double.parseDouble(values[14]));
							tempArrayPinHighGamma.add(Double.parseDouble(values[15]));
							
							}

							if(values[18].equals("Para")) {
								
								if(debug)
								System.out.println("Collecting Paraglider values; Line 214");
								TotalParaTime += 1; /* session time of paraglider*/
							
							tempArrayParaDelta.add(Double.parseDouble(values[8]));
							tempArrayParaTheta.add(Double.parseDouble (values[9]));
							tempArrayParaLowAlpha.add(Double.parseDouble(values[10]));
							tempArrayParaHighAlpha.add(Double.parseDouble(values[11]));
							tempArrayParaLowBeta.add(Double.parseDouble(values[12]));
							tempArrayParaHighBeta.add(Double.parseDouble(values[13]));
							tempArrayParaLowGamma.add(Double.parseDouble(values[14]));
							tempArrayParaHighGamma.add(Double.parseDouble(values[15]));
							}

							if(values[18].equals("Rock")) {

							if(debug)
								System.out.println("Collecting Rock values; Line 222");
								TotalRockTime += 1; /* session time of rock*/
							   
							tempArrayRockDelta.add(Double.parseDouble(values[8]));
							tempArrayRockTheta.add(Double.parseDouble (values[9]));
							tempArrayRockLowAlpha.add(Double.parseDouble(values[10]));
							tempArrayRockHighAlpha.add(Double.parseDouble(values[11]));
							tempArrayRockLowBeta.add(Double.parseDouble(values[12]));
							tempArrayRockHighBeta.add(Double.parseDouble(values[13]));
							tempArrayRockLowGamma.add(Double.parseDouble(values[14]));
							tempArrayRockHighGamma.add(Double.parseDouble(values[15]));
							}

					}// end - if (checking game and value not zero)
				}
			}
		} //end while

		inputStream.close();

	} //end try

	catch (FileNotFoundException e) {
		e.printStackTrace();
	} //end catch

}//end ReadCSVFile

public static void main(String s[]) {

	new AverageEEG();
	AverageEEG.ReadCSVFile();
}
}

