/**
 * Mindfull Project: This program is to calculate the average relaxation per session for pinwheel and paraglider game and 
  the average attention per session for stones game.
   
   When the signal quality is good (i.e when poor signal is zero), and if the gameplay time is greater than the default time taken to collect a token,
   the mean relaxation per session (for pinwheel and paraglider) and mean attention per session (for stones game) is calculated for all the sessions 
   for each participant. Relax or Attn value = zero will not be included into the mean calculation as it does not any level as per neurosky.
   
  
  
 */

import java.util.ArrayList;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.io.PrintStream;
import java.io.FileOutputStream;


/* Created by srilekha Kirshnamachari  on 2016-06-01.
 */



class AverageRA {

    static ArrayList<Integer> tempArrayMedPinwheel;
    static ArrayList<Integer> tempArrayAttRock;
    static ArrayList<Integer> tempArrayMedParaglider;
    static boolean debug = false;

    AverageRA()
    {
        tempArrayMedParaglider = new ArrayList<Integer>();
        tempArrayMedPinwheel = new ArrayList<Integer>();
        tempArrayAttRock = new ArrayList<Integer>();
    }
	
	private static void resetStaticArrays()
	{
		tempArrayMedPinwheel.clear();
		tempArrayMedParaglider.clear();
		tempArrayAttRock.clear();
	}
	
	/* function to calculate the average */
	private static float average(ArrayList<Integer> list) {
	
	// 'average' is undefined if there are no elements in the list.
	if (list == null || list.isEmpty())
		return 0;
	
	// Calculate the summation of the elements in the list
	long sum = 0;
	int n = list.size();
	
	for (int i = 0; i < n; i++)
	{
		sum += list.get(i);
	}
	
	// return the average
	//System.out.println((float)(sum)/n);
	return ((float)(sum)/n);
	
}

    /* function to read the Input.csv file and process data */
    public static void ReadCSVFile() {
		
        String filename = "Input csv file *";  //input file
        Scanner inputStream = null;
        String data = "";
        String signalString = "PoorSig: 0"; // when signal quality is good
        int previousSessionRecord = 1;
        int TotalPinTime = 0; //session time of pinwheel
        int TotalParaTime = 0; // session time of paraglider
        int TotalRockTime = 0; //session time of stones
		
		


        try {

            inputStream = new Scanner(new File(filename));
            inputStream.useDelimiter(",");
			
			PrintStream out = new PrintStream(new FileOutputStream("Output csv file"));
			System.setOut(out);
			System.out.println("SessionNo,Game,AvgScore,TotalRecords");


			//split the csv file based on the delimiter comma
            while (inputStream.hasNext()) {
                data = inputStream.nextLine();
                String[] values = data.split(",");


                /*check if signal is zero - indicating good quality */
                if(values[4].equals(signalString) &&  values[3].equals("[MINDWAVE]") ) {
                    {
                        /* for pin and para - check the med value is not zero;
                           for rock - check if the att value is not zero;
                           then insert them in the data structure
                         */
                        if(  ((values[18].equals("Pin") && !values[5].equals("0")) ||
                                (values[18].equals("Para") && !values[5].equals("0")) ||
                                (values[18].equals("Rock") && !values[6].equals("0"))) ) {


                            if ( (previousSessionRecord != Integer.parseInt(values[1]))  )
                           //if previousSessionRecord is not same as current session no, then print
                            {
								/* check if the gameplay time is greater than the default min_time of the game*/

                                if(TotalPinTime > 5){

                                    System.out.println(previousSessionRecord + ",Pin," + (float) average(tempArrayMedPinwheel) + "," + tempArrayMedPinwheel.size() );
                                }
                                else
                                {
                                    System.out.println(previousSessionRecord+",Pin,0,0");
                                }

                                if(TotalParaTime > 11)
                                {

                                    System.out.println(previousSessionRecord + ",Para," + (float) average(tempArrayMedParaglider) + "," + tempArrayMedParaglider.size());
                                }
                                else
                                {
                                    System.out.println(previousSessionRecord+",Para,0,0");

                                }

                                if(TotalRockTime > 8) {
                                    System.out.println(previousSessionRecord + ",Rock," + (float) average(tempArrayAttRock) + "," + tempArrayAttRock.size() );
                                }
                                else
                                {
                                    System.out.println(previousSessionRecord+",Rock,0,0");
                                }

								/* iterate the session number */    
                                previousSessionRecord +=1;


								/* Reset all variables after printing current session number and going to next session
								*/
                                TotalPinTime = 0;
                                TotalParaTime = 0;
                                TotalRockTime = 0;
								resetStaticArrays();


                            } //end - if checking session number  are same.


                                if(values[18].equals("Pin"))
                                {

                                    TotalPinTime = TotalPinTime+1; 
									tempArrayMedPinwheel.add(Integer.parseInt(values[5])); // 


                                }

                                if(values[18].equals("Para")) {

                                    TotalParaTime = TotalParaTime+1;
									tempArrayMedParaglider.add(Integer.parseInt(values[5]));


                                }

                                if(values[18].equals("Rock")) {

                                    TotalRockTime = TotalRockTime +1;
									tempArrayAttRock.add(Integer.parseInt(values[6]));

                                }

                        }// end - if (checking game and R/A values not zero)
                    }
                }
            } //end while



            inputStream.close();

        } //end try

        catch (FileNotFoundException e) {
            e.printStackTrace();
        } //end catch

    }//end ReadCSVFile

    public static void main(String s[]) {

        new AverageRA();
        AverageRA.ReadCSVFile();
    }
}

