/**
* Mindfull Project: the project is to calculate the Good Quality Signal Percentage (GQSP) for each session for a single participant.

 Computes the number of records where Signal Strength  is "PoorSignal = 0" to the total number of records in a session for a game.

* 
*/

import java.util.ArrayList;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.io.PrintStream;
import java.io.FileOutputStream;



/* Created by srilekha Kirshnamachari  on 2016-06-01.
*/



class GQSP {

static ArrayList<Integer> tempArrayMedPinwheel;
static ArrayList<Integer> tempArrayAttRock;
static ArrayList<Integer> tempArrayMedParaglider;
static boolean debug = false;

GQSP()
{
tempArrayMedParaglider = new ArrayList<Integer>();
tempArrayMedPinwheel = new ArrayList<Integer>();
tempArrayAttRock = new ArrayList<Integer>();
}

public static double average(ArrayList<Integer> list) {


/* test the array */
if(debug) {
	for(int i : list)
	{
		System.out.print(i+",");
	}
	System.out.println("---------------------");
}


// 'average' is undefined if there are no elements in the list.
if (list == null || list.isEmpty())
	return 0.0;
// Calculate the summation of the elements in the list
long sum = 0;
int n = list.size();
// Iterating manually is faster than using an enhanced for loop.
for (int i = 0; i < n; i++)
	sum += list.get(i);
// We don't want to perform an integer division, so the cast is mandatory.
return ((float) sum) / n;
}

public static void ReadCSVFile() {
String filename = "*Input csv file*";
Scanner inputStream = null;
String data = "";
String signalString = "PoorSig: 0";
int previousSessionRecord = 1;
int TotalPinTime = 0;
int PinAboveThreshold = 0;
int TotalParaTime = 0;
int ParaAboveThreshold = 0;
int TotalRockTime = 0;
int RockAboveThreshold = 0;


try {

	inputStream = new Scanner(new File(filename));
	inputStream.useDelimiter(",");
	
	PrintStream out = new PrintStream(new FileOutputStream("Output csv file*"));
	System.setOut(out);
	System.out.println("SessionNo,Game,NoisePercent,TotalNumber");


	while (inputStream.hasNext()) 
	{
		data = inputStream.nextLine();
		String[] values = data.split(",");


		/*the mindwave lines are not blank */
		if( values[3].equals("[MINDWAVE]") )
		{
			if ( (previousSessionRecord != Integer.parseInt(values[1]))  )
				   //if previousSessionRecord is not same as current session no, then print
			{

				/* if the pinwheel gameplay time is greater than default Pinwheel time */
				if(TotalPinTime > 5){
					System.out.println(previousSessionRecord + ",Pin," +  ((float) PinAboveThreshold/TotalPinTime)*100+","+TotalPinTime );
				}
				else
				{
					System.out.println(previousSessionRecord+",Pin,0,0");
				}
				
				/* if the paraglider gameplay time is greater than default paraglider time */
				if(TotalParaTime > 11)
				{
					System.out.println(previousSessionRecord + ",Para," +  ((float) ParaAboveThreshold/TotalParaTime )*100+","+ TotalParaTime );
				}
				else
				{
					System.out.println(previousSessionRecord+",Para,0,0");
				}

				/* If the rock gameplay time is greater than default rock time */
				if(TotalRockTime > 8) {
					System.out.println(previousSessionRecord + ",Rock," + ((float) RockAboveThreshold/TotalRockTime )*100 + "," + TotalRockTime);
				}
				else
				{
					System.out.println(previousSessionRecord+",Rock,0,0");
				}

				previousSessionRecord +=1;

						   
				TotalPinTime = 0;
				TotalParaTime = 0;
				TotalRockTime = 0;
				PinAboveThreshold = 0;
				ParaAboveThreshold = 0;
				RockAboveThreshold = 0;

			} //end - if checking session no are same.


			if(values[18].equals("Pin"))
			{
						  
				TotalPinTime = TotalPinTime+1;

				if(values[4].equals(signalString))
				{
					PinAboveThreshold = PinAboveThreshold + 1;
				}
			} // end - check if Pin

			if(values[18].equals("Para"))
			{
				TotalParaTime = TotalParaTime+1;

				if(values[4].equals(signalString))
				{
					ParaAboveThreshold = ParaAboveThreshold + 1;
				}
						  
			} // end - check if Para

			if(values[18].equals("Rock"))
			{
				TotalRockTime = TotalRockTime +1;

				if(values[4].equals(signalString))
				{
					RockAboveThreshold = RockAboveThreshold + 1;
				}
			}// end - Check if Rock
			
		}// end - check if Mindwave and signal is not empty
		else
		{
			if(debug)
			System.out.println("Line 163: Mindwave/Signal is empty");
		}
	} //end while

	inputStream.close();

} //end try

catch (FileNotFoundException e) {
	e.printStackTrace();
} //end catch

}//end ReadCSVFile

public static void main(String s[]) {

new GQSP();
GQSP.ReadCSVFile();
}
}

